
#include <linux/config.h>

#ifdef CONFIG_MEDUSA

#include <linux/sched.h>
#include <linux/wrapper.h>
#include <linux/slab.h>
#define	EXPORT_SYMTAB
#include <linux/module.h>

#include "medusa.h"

extern struct task_struct * constable;

const char *medusa_cmd( struct medusa_packet *msg, char *data, int datalen, struct medusa_packet *ans )
{
	char * retval = NULL;
	struct task_struct *t;
	unsigned long flags;

//	printk("MEDUSA: Get command !\n");
	ans->answer= MED_ERR;
	switch (msg->cmd) {
		case MED_RESET:
			printk("medusa: Got MED_RESET!\n");
			ans->answer= MED_OK;
			/* FIXME! Dorobit.... */
			break;
		case MED_PRINTK:
			if (!data)
				break;
			printk("medusa: constable: %s\n",data);
			ans->answer= MED_OK;
			break;
		case MED_GET_PROC:
			read_lock(&tasklist_lock);
			if((t=find_task_by_pid
				(msg->u.r_cmd.proc.pid))!=NULL)
			{
				medusa_set_proc_inf(
					&(ans->u.a_cmd.proc),t);
				ans->answer= MED_OK;
			}
			read_unlock(&tasklist_lock);
			break;
		case MED_SET_PROC:
			read_lock(&tasklist_lock);
			if((t=find_task_by_pid
				(msg->u.r_cmd.proc.pid))!=NULL )
			{
				/* read lock nam staci, lebo */
				/* toto nemeni ziadna ina rutina */
				/* na svete a nasa je urcite len 1 */
				medusa_set_proc(
					t,&(msg->u.r_cmd.proc));
				ans->answer= MED_OK;
			}
			read_unlock(&tasklist_lock);
			break;
#ifdef CONFIG_MEDUSA_FORCE
		case MED_FORCE:
			read_lock(&tasklist_lock);
			if((t=find_task_by_pid
				(msg->u.r_cmd.proc.pid))!=NULL )
			{
				spin_lock_irqsave(
					&t->sigmask_lock,
					flags
				);
				
				if(!data) {
					if (t->med.force_code) {
						unsigned char * p =
							t->med.force_code;
						t->med.force_code = NULL;
						kfree(p);
					}
					ans->answer= MED_OK;
				} else if (t->med.force_code == NULL) {
					t->med.force_len = datalen;
					t->med.force_code= data;
					data = NULL; /* kfree() inde */
					ans->answer= MED_OK;
					recalc_sigpending(t);
					if (t->state==TASK_INTERRUPTIBLE
						&& signal_pending(t)
					)
						wake_up_process(t);
#ifdef __SMP__
					spin_lock(&runqueue_lock);
					if (t->has_cpu &&
						t->processor !=
						smp_processor_id()
					)
						smp_send_reschedule
							(t->processor);
					spin_unlock(&runqueue_lock);
#endif
				}
				spin_unlock_irqrestore(
					&t->sigmask_lock,
					flags
				);
			}
			read_unlock(&tasklist_lock);
			break;
#endif
		case MED_GETSTR:
			ans->answer= MED_OK;
			ans->data_len= strlen((char *)(msg->u.r_cmd.arg[0]));
			retval = ((char *)(msg->u.r_cmd.arg[0]));
			break;
		case MED_NOP:
			ans->answer= MED_OK;
			break;
	}

	if (data)
		medusa_putdata(data);

	return retval;
}

#endif /* CONFIG_MEDUSA */

