
#include <linux/config.h>

#ifdef CONFIG_MEDUSA

#include <linux/sched.h>
#include <linux/wrapper.h>
#define	EXPORT_SYMTAB
#include <linux/module.h>

#include "medusa.h"

//#define ALIAS

extern struct task_struct * constable;

void medusa_set_inode_inf( struct m_inode_inf *ii, struct inode *inode)
{
	ii->dev=inode->i_dev;
	ii->ino=inode->i_ino;
	ii->mode=inode->i_mode;
	ii->nlink=inode->i_nlink;
	ii->uid=inode->i_uid;
	ii->gid=inode->i_gid;
	ii->rdev=inode->i_rdev;
	ii->mi=inode->i_med;
}


int medusa_redirect( char *redirect, struct dentry **dentry )
{ __u16 save_act;
  struct dentry *parent,*tmp,*orig;
#ifdef ALIAS
  struct list_head *s,*p;
#endif

#ifdef CONFIG_MEDUSA_ON_NFS
  uid_t save_fsuid;
#endif CONFIG_MEDUSA_ON_NFS
	if( redirect==NULL )	return(0);
  	orig=(*dentry);	*dentry=NULL;
  	parent=dget(orig->d_covers->d_parent);
	dget(parent);	/* potrebujem ho este raz */
	save_act=current->med.med_act;
	current->med.med_act|=MPACT_MAY_CD; /* vynimka !!! */
#ifdef CONFIG_MEDUSA_ON_NFS
	save_fsuid=current->fsuid;
	current->fsuid=0;
#endif CONFIG_MEDUSA_ON_NFS
	/* flag=0 , mode=0 ??? */
	tmp=lookup_dentry(redirect,parent,0); /* urobi jeden dput(parent) */
//printk(KERN_DEBUG "M DBG 1\n");
#ifdef CONFIG_MEDUSA_ON_NFS
	current->fsuid=save_fsuid;
#endif CONFIG_MEDUSA_ON_NFS
	current->med.med_act&=~MPACT_MAY_CD;
	current->med.med_act|= (save_act & MPACT_MAY_CD);
	if( tmp==NULL || IS_ERR(tmp) || !tmp->d_inode )
	{	dput(parent);
		*dentry=orig;
		return -ENOENT;
	}
#ifdef ALIAS
printk(KERN_DEBUG "M DBG 2\n");
	s=&(tmp->d_inode->i_dentry);	/*tmp->d_alias*/
	(*dentry)=NULL;
	for( p=s->next; p!=s; p=p->next )
	{	if( ((*dentry)=list_entry(p,struct dentry,d_alias))->d_parent == parent )
			break;
		(*dentry)=NULL;
	}
	if( !(*dentry) ) /* p==s */
	{	(*dentry)=d_alloc(NULL,&(orig->d_name));
printk(KERN_DEBUG "M DBG 3\n");
		if( *dentry )
		{	(*dentry)->d_parent=dget(parent);
printk(KERN_DEBUG "M DBG 4\n");
			(*dentry)->d_sb=tmp->d_sb;
			inode_inc_count(tmp->d_inode);
//			d_add(*dentry,tmp->d_inode);
			d_instantiate(*dentry,tmp->d_inode);
		} else { 
			dput(tmp);
			dput(parent);
			*dentry=orig;
			return -ENOMEM;
		}
	}
	else	(*dentry)=dget((*dentry));
printk(KERN_DEBUG "M DBG 5\n");
	dput(tmp);
#else
	*dentry=tmp;
#endif
	dput(parent);
	dput(orig);
	return(0);
}

int medusa_act( int pact, int act, int may_red, struct dentry **dentry, const char *str, int len, __u32 info1, __u32 info2 )
{ char *redirect;
  struct medusa_packet msg;
	msg.cmd=MED_IACT;
	msg.u.r_iact.pact=pact;
	msg.u.r_iact.act=act;
	if( dentry!=NULL )
		medusa_set_inode_inf(&(msg.u.r_iact.inode),(*dentry)->d_inode);
	else	memset(&(msg.u.r_iact.inode),0,sizeof(struct m_inode_inf));
	medusa_set_proc_inf(&(msg.u.r_iact.proc),current);
	msg.u.r_iact.info1=info1;
	msg.u.r_iact.info2=info2;
	if( str!=NULL )	msg.data_len=len;
	else		msg.data_len=0;
	redirect=medusa_request(&msg,str);
	if( (!may_red || dentry==NULL) && redirect!=NULL )
	{	medusa_putdata(redirect);
		redirect=NULL;
		printk("MEDUSA: Invalid redirection!\n");
	}
	if( msg.answer != MED_ERR )
		medusa_set_proc(current,&(msg.u.a_iact.proc));
	if( msg.answer == MED_NOT )
	{	if( redirect!=NULL )	medusa_putdata(redirect);
		return -EPERM;
	}
	if( redirect!=NULL )
	{ int r;
		r=medusa_redirect(redirect,dentry);
		medusa_putdata(redirect);
		if( r<0 )	return(r);
	}
	if( msg.answer == MED_YES )
		return(0);
	return(1);
}

int medusa_iact( int act, int may_red, struct dentry **dentry, const char *str, int len, __u32 info1, __u32 info2 )
{ int r;
	r=1;
	if( current->med.med_iact & act )
	{	r=medusa_act(MPACT_IOP,act,may_red,dentry,str,len,info1,info2);
		if( r<=0 )	return(r);
	}
	if( med_valid( &((*dentry)->d_inode->i_med) )
		&& ((*dentry)->d_inode->i_med.med_act & act) )
	{	r=medusa_act(0,act,may_red,dentry,str,len,info1,info2);
	}
	return(r);
}

int medusa_dact( int act, struct dentry *dentry, __u32 info )
{ int r;
	if( dentry==NULL || IS_ERR(dentry) || dentry->d_inode==NULL )
		return(1);
	r=medusa_iact(act, 0, &dentry,
		dentry->d_name.name, dentry->d_name.len,info,0);
	return(r);
}

int medusa_diract( int act, struct dentry *dentry, __u32 info )
{ int r;
  struct dentry *parent;
	if( dentry==NULL || IS_ERR(dentry) )	return(1);
	parent=dget(dentry->d_covers->d_parent);
	r=medusa_iact(act, 0, &parent, dentry->d_name.name, dentry->d_name.len,
			info,0);
	dput(parent);
	return(r);
}

int medusa_exec(char *filename,struct dentry **dentry,__u32 argv,__u32 envp)
{ int r;
	r=1;
	if( current->med.med_act & MPACT_EXEC )
	{	r=medusa_act(MPACT_EXEC,(dentry!=NULL ? 0 : 1),
			1,dentry,filename,strlen(filename)+1,argv,envp);
		if( r<=0 )	return(r);
	}
	if( dentry!=NULL )
		r=medusa_iact(MIACT_EXEC,1,dentry,filename,strlen(filename)+1,
				argv,envp);
	return(r);
}

int medusa_sexec(struct linux_binprm *bprm, int new_permitted)
{ struct medusa_packet msg;
  char *s;
	if( !(current->med.med_act & MPACT_SEXEC) )	return(1);

	msg.cmd=MED_PACT;
	msg.u.r_pact.act=MPACT_SEXEC;
	medusa_set_proc_inf(&(msg.u.r_pact.proc),current);
	medusa_set_proc_inf(&(msg.u.r_pact.target),current);
	cap_t(msg.u.r_pact.target.cap_permitted)=new_permitted;
	cap_t(msg.u.r_pact.target.cap_effective)=new_permitted & 
						  (bprm->cap_effective);
	cap_t(msg.u.r_pact.target.suid)=
		cap_t(msg.u.r_pact.target.euid)=
		cap_t(msg.u.r_pact.target.fsuid)=bprm->e_uid;
	cap_t(msg.u.r_pact.target.sgid)=
		cap_t(msg.u.r_pact.target.egid)=
		cap_t(msg.u.r_pact.target.fsgid)=bprm->e_gid;
	msg.u.r_pact.info1=bprm->dentry->d_inode->i_med.med_vs;
	msg.u.r_pact.info2=bprm->dentry->d_inode->i_med.cinfo;
	msg.data_len=strlen(bprm->filename);
	s=medusa_request(&msg,bprm->filename);
	if( s!=NULL )
	{	medusa_putdata(s);
		printk("MEDUSA: Invalid incomming data!\n");
	}
	if( msg.answer != MED_ERR )
		medusa_set_proc(current,&(msg.u.a_pact.proc));
	if( msg.answer == MED_NOT )
		return -EPERM;
	if( msg.answer == MED_YES )
		return(0);
	return(1);
}

int medusa_get_inode( struct inode *inode )
{
	struct dentry *dentry;

	if (!constable)
		return 0;
	dentry=dget(list_entry(inode->i_dentry.next,struct dentry,d_alias));
	medusa_get_medinfo(dentry);
	dput(dentry);
	if( !med_valid(&(inode->i_med)) )
		printk("MEDUSA: Invalid i_med in inode [%04x]:%ld\n",
			inode->i_dev,inode->i_ino);
	return 0;
}

/* ak vrati 0 - povolene, uz dalej netestuj */
/* ak vrati 1 - pokracuj v testovani */
int medusa_permission(struct inode * inode,int mask)
{ int r;
  struct dentry *dentry;
	dentry=dget(list_entry(inode->i_dentry.next,struct dentry,d_alias));
	medusa_get_medinfo(dentry);
	r=1;
	if( (current->med.med_act & MPACT_MAY_CD)
		&& (mask==MAY_EXEC || mask==0) && S_ISDIR(inode->i_mode) )
		r=0;	/* povolene - vynimka */
	if( r>0 )
		r=medusa_dact(MIACT_PERMISION, dentry, (__u32)mask );
	dput(dentry);
	if( r<=0 )	return(r);
	if( !med_valid( &(inode->i_med) ) )
	{	medusa_get_inode(inode);
		if( !med_valid( &(inode->i_med)) )
		{	return 1;	/* ako keby tu medusa vobec nebola */
		}
	}
	if( !(inode->i_med.med_vs & current->med.med_vs) )
		return -EPERM;
					/* current->med.med_w_vs ??? */
	if( (mask & S_IWOTH) && !(inode->i_med.med_vs & current->med.med_m_vs) )
		return -EPERM;
	return 1;
}

int medusa_notify_change(struct dentry * dentry, struct iattr *attr)
{
	struct inode *inode = dentry->d_inode;
	
	if( !med_valid( &(inode->i_med)) )
	{	medusa_get_medinfo(dentry);
		if( !med_valid( &(inode->i_med)) )
		{	medusa_get_inode(inode);
			if( !med_valid( &(inode->i_med)) )
			{	return 0; /* ako keby tu medusa vobec nebola */
			}
		}
	}
	if( !(inode->i_med.med_vs & current->med.med_vs) )
		return -EPERM;
	if( !(inode->i_med.med_vs & current->med.med_m_vs) )
		return -EPERM;
	return 0;
}

int medusa_get_medinfo(struct dentry *dentry)
{ int len;
  const char *name;
  char *str;
  struct dentry *parent,*covers;
  struct medusa_packet msg;
	if (!constable)
		return 0;
	if (
		!dentry ||
		!(dentry->d_inode) ||
		med_valid(&(dentry->d_inode->i_med))
	)
		return 0;

	covers=dget(dentry->d_covers);
	len=covers->d_name.len;
	name=covers->d_name.name;
	parent=dget(covers->d_parent->d_covers);

	if(parent==NULL || parent->d_inode==NULL) {	
		dput(covers);
		return(0);
	}
	
	if (!med_valid(&(parent->d_inode->i_med))
		&& parent!=parent->d_parent
		&& medusa_get_medinfo(parent)<=0
	) {
		dput(parent);
		dput(covers);
		return(0);
	}
	
	if( med_valid(&(parent->d_inode->i_med))
		&& (parent->d_inode->i_med.med_act & MIACT_INHERIT)
	) {
		dentry->d_inode->i_med=parent->d_inode->i_med;
		dput(parent);
		dput(covers);
		return(1);
	}

	msg.cmd=MED_IGET;
	medusa_set_inode_inf(&(msg.u.r_iget.inode),covers->d_inode);
	medusa_set_inode_inf(&(msg.u.r_iget.parent),parent->d_inode);
	msg.data_len=len;
	dput(parent);
	str=medusa_request(&msg,name);
	if( str!=NULL )
		medusa_putdata(str);
	dput(covers);
	if( msg.answer == MED_NOT )
		return(-1);
	if( msg.answer == MED_OK || msg.answer == MED_YES )
	{	dentry->d_inode->i_med = msg.u.a_iget.inode.mi;
		dentry->d_inode->i_med.magic = medusa_magic;
		return(1);
	}
	return(0);
}

int medusa_lookup(struct inode * dir, struct dentry **dentry)
{ int r;
	if( *dentry==NULL || IS_ERR((*dentry)) || !(*dentry)->d_inode )
		return(0);
	if( ! med_valid( &((*dentry)->d_inode->i_med) ) )
	{	r=medusa_get_medinfo(*dentry);
		if( r<0 )
		{	dput(*dentry);
			*dentry=ERR_PTR(-EPERM);
			return -EPERM;
		}
	}
	r=medusa_iact(MIACT_ACCESS,1,dentry,NULL,0,0,0);
	if( r<0 )
	{	dput(*dentry);
		*dentry=ERR_PTR(r);
		return(r);
	}
	return(r);
}

void medusa_clean_inode(struct inode *inode)
{
	inode->i_med.med_act=0;
	inode->i_med.magic=0;
}

#endif CONFIG_MEDUSA

