/* Medusa DS9 header file
 * by Marek Zelem
 * (c)1998 All rights reserved.
 */

#ifndef _MEDUSA_KERNEL_H_
#define _MEDUSA_KERNEL_H_

#include <linux/sys.h>
#include <linux/types.h>

/* rozsirenie struct task_struct */
struct med_proc {
	__u16	med_vs;		/* bitmap of 16 virtual spaces (tie vidi) */
	__u16	med_vs_sw;	/* maska, ktore moze prepinat (pre med_vs) */
	__u16	med_m_vs;	/* bitmap, do ktorych moze modifik. (chmody) */
	__u16	med_w_vs;	/* bitmap, ktore moze prepisovat/zapisovat */
	__u16	med_act;   /* akcie ktore vyzaduju potvrdenie od constabla */
	__u16	med_iact;  /* iakcie ktore vyzaduju potvrdenie od constabla */
	__u32	med_user;  /* for free deamon use */
#ifdef CONFIG_MEDUSA_SYSCALL
	__u32	med_syscall[NR_syscalls/32];	/* binmap syscallov, ktore sa oznamuju */
#endif
#ifdef CONFIG_MEDUSA_FORCE
	void	*force_code;	/* Kod na vnutenie alebo NULL, kfree */
	int	force_len;	/* dlzka kodu na vnutenie */
#endif
		};

/* rozsirenie struct inode */
struct med_inode {
	__u16	med_vs;	 /* bitmap of 16 virtual spaces */
	__u16	med_act; /* akcie ktore vyzaduju potvrdenie od constabla */
	u_long	cinfo;	 /* info for constable */
	__u16	magic;	 /* ci je aktualny */
		 };

extern struct task_struct * constable;
int medusa_capable( int cap );

#endif /* _MEDUSA_KERNEL_H_ */

