#include <linux/config.h>
#include <linux/sched.h>
#include <linux/unistd.h>
#include <linux/medusa.h>
#include <linux/medusa_syscall.h>

extern struct task_struct * constable;

volatile asmlinkage int medusa_syscall_watch(
		unsigned int eax,	/* in: syscall, out: retval */
		struct task_struct * curr,
		volatile unsigned int p1,
		volatile unsigned int p2,
		volatile unsigned int p3,
		volatile unsigned int p4,
		volatile unsigned int p5
	)
{
	struct medusa_packet msg;
	char * foo;
	
	if (!constable)
		return MED_SYSCALL_ALLOW;

	msg.cmd = MED_TRACE;
	msg.u.r_trace.syscall = (__u16)eax;
	msg.u.r_trace.arg[0] = (__u32)p1;
	msg.u.r_trace.arg[1] = (__u32)p2;
	msg.u.r_trace.arg[2] = (__u32)p3;
	msg.u.r_trace.arg[3] = (__u32)p4;
	msg.u.r_trace.arg[4] = (__u32)p5;
	medusa_set_proc_inf(&(msg.u.r_trace.proc),current);
	msg.data_len = 0;

	foo = medusa_request(&msg, NULL);

	if (foo)
		medusa_putdata(foo);
	
        if (msg.answer != MED_ERR) {
		medusa_set_proc(current,&(msg.u.a_trace.proc));
		(__u32)p1 = msg.u.a_trace.arg[0];
		(__u32)p2 = msg.u.a_trace.arg[1];
		(__u32)p3 = msg.u.a_trace.arg[2];
		(__u32)p4 = msg.u.a_trace.arg[3];
		(__u32)p5 = msg.u.a_trace.arg[4];
	}

	switch (msg.answer) {
		case MED_YES:
			return MED_SYSCALL_SKIPTRACE;
		case MED_NOT:
			eax = msg.u.a_trace.retval;
			return MED_SYSCALL_DENY;
	}
	return MED_SYSCALL_ALLOW;
}

