
#include "log.h"
#include "language.h"
#include <regex.h>

typedef struct {
		kdev_t		dev;
		unsigned long	ino;
	       } inod_t;

struct med_s	{
	struct m_proc_inf	proc;	/* proces ktory to sposobil */
	struct m_inode_inf	*inode;	/* len informacne */
	struct m_proc_inf	*target;/* len informacne */
	char			*data;	/* data z requestu */
	__u32		action;	/* akcia (napr. fsact ...) */
	__u32		info1;	/* z medusa packetu od kernelu */
	__u32		info2;	/* z medusa packetu od kernelu */
	__u32		trace_arg[5]; /* trace argumenty od kernelu */
	int		answer;	/* tu nastavit odpoved pre kernel */
	int		apply_mode;	/* 0=iba tento proc. */
	char		*redirect; /* tu nastavit presmerovanie */
		};

#define	APPLY_PARENT	1
#define	APPLY_TO_PARENT	2
#define	APPLY_TO_LOGIN	3

#define	MIACT_RECURSIVE	MIACT_VALID
#define	MIACT_IGET	0

typedef struct fentry_s	{
	struct fentry_s	*next;
	__u16		act;
	udata		*program;
	int		proglen;
			} fentry_t;

typedef struct fpattern_s {
	struct fpattern_s *next;
	fentry_t	*ent;	/* iba jeden, nesmie byt zretazeny !!! */
	char		*path;
	regex_t		reg;
			  } fpattern_t;

typedef struct files_s	{
	struct files_s	*parent;
	struct files_s	*child;
	struct files_s	*next;
	char		*name;
	fentry_t	*ent;
	fpattern_t	*patterns;
	inod_t		inode;
			} files_t;


struct c_module	{
	struct c_module	*next;
	int (*func)(struct medusa_packet*,char *,struct medusa_packet *,char **);
		};

int add_module( int(*func)(struct medusa_packet*,char *,
		struct medusa_packet *,char **) );
char *med_cmd( struct medusa_packet *msg, char *data );

int modules_init( void );


int apply( int mode, struct med_s *orig, udata *prog );

/* maskmatch.c */
int maskmatch(char * filename, char * mask);

